/* -*- mode: c++; c-basic-offset: 3; -*- */
#include "framecache.hh"
#include <string>
#include <iostream>

using namespace std;

int
main (int argc, const char* argv[]) {
  framecache::gps_type start=0, end=0;
  std::string in, out, dir, pfx;
  for (int i=1; i<argc; i++) {
    string argi = argv[i];
    bool num = (argi.find_first_of("0123456789") == 0);
    if (argi == "-d") {
      dir = argv[++i];
    } else if (argi == "-i") {
      in = argv[++i];
    } else if (argi == "-o") {
      out = argv[++i];
    } else if (pfx.empty()) {
      pfx = argi;
    } else if (num && !start) {
      start = strtoul(argv[i], 0, 0);
    } else if (num && !end) {
      end = strtoul(argv[i], 0, 0);
    } else {
      cerr << "Unknown argument: " << argi << endl;
    }
  }
  
  //------------------------------------  process the frame cache
  framecache fc;
  if (!in.empty())  fc.parse_cacheFile(in);
  if (!dir.empty()) fc.parse_directory(dir);
  if (!out.empty()) fc.write(out);

  //-------------------------------------  list requested frames.
  if (start || end) {
    framecache::str_vect frames;
    fc.get_list(pfx, start, end, frames);
    for (auto p=frames.begin(); p != frames.end(); p++) {
      cout << *p << endl;
    }
  }
}
